#ifdef ALG_BLOOM
#include "alg_bloom/bloom.h"

#define filter_t bloom_filter_t
#define filter_init bloom_filter_init
#define filter_deinit bloom_filter_deinit 
#define filter_add bloom_filter_add
#define filter_remove bloom_filter_remove
#define filter_query bloom_filter_query
#endif // ALG_BLOOM

#ifdef ALG_CBF4
#define FILTER_CAN_REMOVE
#include "alg_cbf4/cbf4.h"

#define filter_t cbf4_t 
#define filter_init cbf4_init
#define filter_deinit cbf4_deinit 
#define filter_add cbf4_add
#define filter_remove cbf4_remove
#define filter_query cbf4_query
#endif // ALG_CBF4


#ifdef FILTER_CAN_REMOVE
#define ARGC_REQ 5
#else
#define ARGC_REQ 4
#endif // FILTER_CAN_REMOVE

#if 0
#define trace() fprintf(stderr, "%s:%d ", __func__, __LINE__)
#else
#define trace()
#endif
