// htable_begin.c
// IJC-DU2, priklad 2, 21.4.2009
// Autor: Lukas Kekely, xkekel00
#include "htable.h"

struct htable_listitem *htable_lookup(struct htable_t *t, uint32_t key)
{
    //if (t==NULL||key==NULL) return NULL;  //nieco zle [zakomentovane pre EFEKTIVITU!!]
    uint32_t i=hash_function(key,t->size);  //zistenie indexu cez hash
    struct htable_listitem *pom=t->p[i];
    while (pom!=NULL&&pom->key<key) pom=pom->next; //prebublavam zoznamom do konca abo do zhody
    if(pom==NULL||pom->key!=key) return NULL;
    else return pom;
}

int htable_insert(struct htable_t *t, uint32_t key, uint32_t data)
{
    if (t==NULL) return 0;  //nieco zle
    int i=hash_function(key,t->size);  //zistenie indexu cez hash
    struct htable_listitem **pom=&(t->p[i]);
    while ((*pom)!=NULL&&(*pom)->key<key) pom=&((*pom)->next); //prebublavam zoznamom do konca abo do zhody
    if(*pom!=NULL&&(*pom)->key==key)
    {
        (*pom)->data=data; //zaznam uz existuje, len prepisem data
        return 1;
    }
    struct htable_listitem *nitem=NULL;
    if ((nitem=malloc(sizeof(struct htable_listitem)))==NULL) return 0;
    nitem->key=key;
    nitem->data=data;
    nitem->next=(*pom); //novy ukazuje tam kde ukazoval povodny
    *pom=nitem;         //povodny ukazuje na novy
    return 1;
}

void htable_clear(struct htable_t *t)
{
    if (t==NULL) return; //neni tabulka
    struct htable_listitem *pom=NULL;
    for (int i=0; i<t->size; i++)  //prejdem vsetky indexy
        while (t->p[i]!=NULL)      //a vsetky prvky zoznamov
        {
            pom=t->p[i]->next;
            free(t->p[i]); //potom cely zaznam
            t->p[i]=pom;
        }
}

int htable_init(struct htable_t *t, unsigned real_size)
{
    unsigned i=1;       //prevod na mocninu 2
    t->size=0;
    while(real_size>i){i<<=1; t->size++;}
    real_size=i;
    if ((t->p=malloc(sizeof(struct htable_listitem *)*real_size))==NULL) return 0; //alokuj pole v nej
    for (i=0; i<real_size; i++) t->p[i]=NULL; //vyNULLuj
    return 1;
}

void htable_free(struct htable_t *t)
{
    if (t==NULL) return;
    if (t->p==NULL) return;
    htable_clear(t);  //upracem obsah tabulky
    free(t->p); //zrusim pole v nej
}



/*
struct htable_iterator htable_end(struct htable_t *t)
{
    struct htable_iterator pom={t,-1,NULL};
    if (pom.htptr==NULL) return pom;  //nemam tabulku
    for (int i=pom.htptr->size-1; i>=0; i--) //od posledneho indexu
        if (pom.htptr->p[i]!=NULL)
        {
            pom.index=i;     //najdem prvy neNULLovy (ale ptr necham na NULL, zmenim len index)
            return pom;
        }
    return pom; //prazdna tabulka => -1
}

struct htable_iterator htable_begin(struct htable_t *t)
{
    struct htable_iterator pom={t,-1,NULL};
    if (pom.htptr==NULL) return pom;  //nedostal som tabulku
    for (int i=0; i<pom.htptr->size; i++) //zacnem od prveho indexu
        if (pom.htptr->p[i]!=NULL) //a najdem prvy neNULLovy
        {
            pom.index=i;
            pom.ptr=pom.htptr->p[i];
            return pom;
        }
    return pom;  //ak je tab prazdna vrati sa -1
}

struct htable_iterator htable_it_next(struct htable_iterator it)
{
    if (it.htptr==NULL||it.index<0||it.index>=it.htptr->size||it.ptr==NULL)
        return it;  //nieco je zle
    if (it.ptr->next!=NULL) //vrati dalsi prvok zoznamu
        { it.ptr=it.ptr->next; return it; }
    it.ptr=NULL;
    if (!htable_it_eq(it,htable_end(it.htptr))) //ak som na konci neposuvam sa
        while((it.ptr=it.htptr->p[++(it.index)])==NULL&&it.index<it.htptr->size-1); //inak najdem dalsi neNULLovy index
    return it;
}

inline bool htable_it_eq(struct htable_iterator it1, struct htable_iterator it2)
{
    return (it1.htptr==it2.htptr&&it1.ptr==it2.ptr&&it1.index==it2.index)?true:false;
}

inline struct htable_listitem *htable_it_deref(struct htable_iterator i)
{
    return i.ptr;
}
*/

